Ruby: pm_range_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_range_node Struct Reference

RangeNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | left
| RangeNode#left.
struct pm_node * | right
| RangeNode#right.
pm_location_t | operator_loc
| RangeNode#operator_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

RangeNode.

Represents the use of the .. or ... operators.

    1..2
    ^^^^

    c if a =~ /left/ ... b =~ /right/
         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Type: ::PM_RANGE_NODE

Flags (#pm_range_flags):

- ::PM_RANGE_FLAGS_EXCLUDE_END

Definition at line 6877 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_range_node::base

The embedded base node.

Definition at line 6879 of file ast.h.

Referenced by pm_dump_json().

## ◆ left

struct pm_node* pm_range_node::left

RangeNode#left.

The left-hand side of the range, if present. It can be either nil or any non-void expression.

    1...
    ^

    hello...goodbye
    ^^^^^

Definition at line 6893 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ operator_loc

pm_location_t pm_range_node::operator_loc

RangeNode#operator_loc.

The location of the .. or ... operator.

Definition at line 6914 of file ast.h.

Referenced by pm_dump_json().

## ◆ right

struct pm_node* pm_range_node::right

RangeNode#right.

The right-hand side of the range, if present. It can be either nil or any non-void expression.

    ..5
      ^

    1...foo
        ^^^

If neither right-hand or left-hand side was included, this will be a MissingNode.

Definition at line 6907 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h